package com.zksy.web.controller.basicData;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.common.annotation.Log;
import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.enums.BusinessType;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmCivilManagementDishonesty;
import com.zksy.system.basicData.service.CrmCivilManagementDishonestyService;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 民政管理失信Controller
 *
 * @author sy
 * @date 2024-06-13
 */
@RestController
@RequestMapping("/crmCivilManagementDishonesty")
@Api(tags = "民政管理失信", description = "民政管理失信desc")
public class CrmCivilManagementDishonestyController extends BaseController{

    @Autowired
    private CrmCivilManagementDishonestyService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "民政管理失信搜索getById")
    public CrmCivilManagementDishonesty getById(@PathVariable String borrowId) {
        return service.getById(borrowId);
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "民政管理失信分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "民政管理失信查询所有")
    public List<CrmCivilManagementDishonesty> getList(String conditionJson) throws Exception {
        return service.list(SearchUtil.parseWhereSql(conditionJson));
    }

    /**
     * 新增民政管理失信
     */
    @PostMapping("/save")
    @ApiOperation(value = "民政管理失信新增")
    @Log(title = "新增民政管理失信", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmCivilManagementDishonesty crmCivilManagementDishonesty) {
        return service.save(crmCivilManagementDishonesty);
    }

    /**
     * 修改民政管理失信
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "民政管理失信修改")
    @Log(title = "修改民政管理失信", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmCivilManagementDishonesty crmCivilManagementDishonesty) {
        return service.updateById(crmCivilManagementDishonesty);
    }

    /**
     * 导入民政管理失信
     */
    @ApiOperation("民政管理失信导入")
    @Log(title = "民政管理失信", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmCivilManagementDishonesty> crmCivilManagementDishonestyAll = service.list();
            List<CrmCivilManagementDishonesty> list = ExcelUtils.readMultipartFile(file, CrmCivilManagementDishonesty.class,CrmCivilManagementDishonesty.class.getDeclaredFields().length - 2);
            if(crmCivilManagementDishonestyAll != null && crmCivilManagementDishonestyAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("民政管理失信导出")
    @Log(title = "民政管理失信", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmCivilManagementDishonesty> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"民政管理失信",wrapperList,CrmCivilManagementDishonesty.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "民政管理失信", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除民政管理失信", notes = "删除民政管理失信")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"民政管理失信模板");
    }
}

